#include <stdlib.h>
#include <string.h>
#define YYBYACC 1
#define YYMAJOR 1
#define YYMINOR 9
#define YYLEX yylex()
#define YYEMPTY -1
#define yyclearin (yychar=(YYEMPTY))
#define yyerrok (yyerrflag=0)
#define YYRECOVERING() (yyerrflag!=0)
#define YYPREFIX "yy"
#line 68 "gram.y"
#include <stdio.h>
#include <ctype.h>
#include "twm.h"
#include "menus.h"
#include "list.h"
#include "util.h"
#include "screen.h"
#include "parse.h"
#include "add_window.h"
#include "icons.h"
#include <X11/Xos.h>
#include <X11/Xmu/CharSet.h>

static char *Action = "";
static char *Name = "";
static MenuRoot	*root, *pull = NULL;

static MenuRoot *GetRoot ( const char *name, const char *fore, const char *back );
static void GotButton ( int butt, int func );
static void GotKey ( char *key, int func );
static void GotTitleButton ( char *bitmapname, int func, Bool rightside );
static Bool CheckWarpScreenArg ( char *s );
static Bool CheckWarpRingArg ( char *s );
static Bool CheckColormapArg ( char *s );
static void RemoveDQuote ( char *str );

static char *ptr;
static name_list **list;
static int cont = 0;
static int color;
int mods = 0;
unsigned int mods_used = (ShiftMask | ControlMask | Mod1Mask);

extern int yylineno;
static void yyerror ( const char *s );

#line 106 "gram.y"
#ifndef YYSTYPE_DEFINED
#define YYSTYPE_DEFINED
typedef union
{
    int num;
    char *ptr;
} YYSTYPE;
#endif /* YYSTYPE_DEFINED */
#line 59 "gram.c"
#define LB 257
#define RB 258
#define LP 259
#define RP 260
#define MENUS 261
#define MENU 262
#define BUTTON 263
#define DEFAULT_FUNCTION 264
#define PLUS 265
#define MINUS 266
#define ALL 267
#define OR 268
#define CURSORS 269
#define PIXMAPS 270
#define ICONS 271
#define COLOR 272
#define SAVECOLOR 273
#define MONOCHROME 274
#define FUNCTION 275
#define WINDOW_FUNCTION 276
#define ZOOM 277
#define MAKE_TITLE 278
#define GRAYSCALE 279
#define NO_TITLE 280
#define AUTO_RAISE 281
#define NO_HILITE 282
#define ICON_REGION 283
#define META 284
#define SHIFT 285
#define LOCK 286
#define CONTROL 287
#define WINDOW 288
#define TITLE 289
#define ICON 290
#define ROOT 291
#define FRAME 292
#define COLON 293
#define EQUALS 294
#define SQUEEZE_TITLE 295
#define DONT_SQUEEZE_TITLE 296
#define START_ICONIFIED 297
#define NO_TITLE_HILITE 298
#define TITLE_HILITE 299
#define MOVE 300
#define RESIZE 301
#define WAIT 302
#define SELECT 303
#define KILL 304
#define LEFT_TITLEBUTTON 305
#define RIGHT_TITLEBUTTON 306
#define NUMBER 307
#define KEYWORD 308
#define NKEYWORD 309
#define CKEYWORD 310
#define CLKEYWORD 311
#define FKEYWORD 312
#define FSKEYWORD 313
#define SKEYWORD 314
#define DKEYWORD 315
#define JKEYWORD 316
#define WINDOW_RING 317
#define WARP_CURSOR 318
#define ERRORTOKEN 319
#define NO_STACKMODE 320
#define STRING 321
#define YYERRCODE 256
const short yylhs[] =
	{                                        -1,
    0,   22,   22,    6,    6,    6,    6,    6,    6,    6,
    6,    6,    6,    6,    6,    6,    6,    6,    6,   23,
    6,    6,   24,    6,    6,   25,    6,    6,   26,    6,
    6,   27,    6,   28,    6,   29,    6,   30,    6,   31,
    6,   32,    6,   34,    6,   35,    6,   36,    6,    6,
   37,    6,    6,    6,   38,    6,    6,   39,    6,   11,
   12,   13,   20,   21,   40,   40,   43,   43,   43,   43,
   43,   43,   41,   41,   44,   44,   44,   44,   44,   44,
   44,   42,   42,   45,   45,   45,   45,   45,   45,   45,
   45,    2,   46,   46,   47,    3,   48,   48,   49,   49,
   49,   49,   49,   49,   49,   49,   49,   49,   49,   49,
   49,   49,   49,   49,   49,   49,   49,   49,    4,   50,
   50,   15,   51,   15,   15,    5,   52,   52,   53,   53,
    7,   54,   54,   55,   14,   56,   14,   14,   58,   14,
   57,   57,    8,   59,   59,   60,   33,   61,   61,   62,
    9,   63,   63,   64,   10,   65,   65,   66,   66,   16,
   16,   19,   19,   19,   17,    1,   18,
};
const short yylen[] =
	{                                         2,
    1,    0,    2,    1,    1,    1,    1,    1,    6,    2,
    1,    2,    2,    4,    4,    2,    2,    2,    2,    0,
    3,    1,    0,    3,    1,    0,    3,    1,    0,    3,
    1,    0,    3,    0,    3,    0,    3,    0,    9,    0,
    4,    0,    4,    0,    3,    0,    3,    0,    3,    2,
    0,    3,    2,    2,    0,    3,    1,    0,    3,    1,
    2,    2,    6,    6,    0,    2,    1,    1,    1,    1,
    2,    1,    0,    2,    1,    1,    1,    1,    1,    1,
    1,    0,    2,    1,    1,    1,    1,    1,    1,    1,
    1,    3,    0,    2,    2,    3,    0,    2,    3,    2,
    3,    2,    3,    2,    3,    2,    3,    2,    3,    2,
    3,    2,    3,    2,    3,    2,    3,    2,    3,    0,
    2,    2,    0,    4,    2,    3,    0,    2,    1,    1,
    3,    0,    2,    2,    1,    0,    5,    1,    0,    3,
    0,    5,    3,    0,    2,    1,    3,    0,    2,    2,
    3,    0,    2,    1,    3,    0,    2,    2,    7,    1,
    2,    1,    2,    2,    2,    1,    1,
};
const short yydefred[] =
	{                                      2,
    0,    0,    4,    0,    0,    0,    0,    0,   44,   46,
    0,   51,    0,    0,    0,   32,   48,    0,   36,    0,
    0,    0,    0,   34,    0,    0,    0,   60,    0,    0,
   58,    0,    0,  166,    0,    3,    5,    6,    7,    8,
    0,    0,  167,  165,  160,    0,   53,   97,   13,   93,
   12,    0,    0,  127,   50,    0,   42,   54,   10,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,   62,   61,    0,    0,    0,   65,   18,   65,   16,
   17,   19,    0,    0,  161,    0,    0,  148,   45,  120,
   47,    0,   52,    0,  144,   33,   49,   30,   37,   24,
    0,  141,  140,   35,   21,    0,    0,   59,   56,   27,
    0,    0,    0,  156,   41,   96,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,   98,   92,    0,   94,
    0,    0,  126,  130,  129,  128,  152,   43,    0,    0,
    0,   14,   15,   72,    0,   68,   69,   70,   82,   66,
   73,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,   95,  147,    0,  149,  119,    0,    0,
  121,    0,  143,  146,  145,    0,  137,    0,   71,    0,
    0,    0,  155,    0,  157,  113,  105,  101,  103,   99,
  107,  109,  111,  115,  117,  150,  125,    0,  151,  154,
  153,    9,    0,   89,   90,   84,   85,   86,   87,   88,
    0,   91,   83,   80,   81,   75,   76,   77,   78,   79,
    0,   74,   38,    0,  158,    0,    0,    0,  162,    0,
   64,   63,    0,    0,  132,  124,  163,  164,  142,   39,
    0,    0,    0,  131,    0,  133,    0,  134,  159,
};
const short yydgoto[] =
	{                                       1,
   35,   51,   49,   91,   55,   36,  236,   96,  138,  115,
   37,   38,   39,   40,  171,   47,   41,   44,  230,   82,
   78,    2,   69,   64,   76,   62,   60,   68,   63,  233,
   84,   94,   89,   52,   53,   61,   56,   75,   74,  111,
  181,  180,  150,  222,  213,   87,  130,   86,  127,  132,
  226,   92,  136,  242,  246,   66,  141,   67,  139,  175,
  131,  167,  172,  201,  153,  185,
};
const short yysindex[] =
	{                                      0,
    0,  -92,    0, -305, -288, -298, -236, -222,    0,    0,
 -221,    0, -305, -298, -288,    0,    0,    0,    0,    0,
 -305,    0,    0,    0,    0, -305, -305,    0, -288, -305,
    0,    0,    0,    0, -265,    0,    0,    0,    0,    0,
 -261, -227,    0,    0,    0, -305,    0,    0,    0,    0,
    0, -219, -218,    0,    0, -218,    0,    0,    0, -214,
 -218, -214, -214, -214, -271, -203, -214, -214, -214, -238,
 -237,    0,    0, -214, -214, -214,    0,    0,    0,    0,
    0,    0, -305, -196,    0, -160, -246,    0,    0,    0,
    0, -256,    0, -195,    0,    0,    0,    0,    0,    0,
 -252,    0,    0,    0,    0, -298, -298,    0,    0,    0,
 -193,  -53, -229,    0,    0,    0, -305, -305, -305, -305,
 -305, -305, -305, -305, -305, -305,    0,    0, -305,    0,
 -253, -224,    0,    0,    0,    0,    0,    0, -251, -288,
 -250,    0,    0,    0, -288,    0,    0,    0,    0,    0,
    0, -305, -248, -305, -305, -305, -305, -305, -305, -305,
 -305, -305, -305,    0,    0, -305,    0,    0, -305, -305,
    0, -254,    0,    0,    0, -288,    0, -244,    0, -243,
  -44, -194,    0, -228,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0, -225,    0,    0,    0,    0,    0,    0,    0,
 -298,    0,    0,    0,    0,    0,    0,    0,    0,    0,
 -298,    0,    0, -305,    0, -188, -288, -288,    0, -288,
    0,    0, -196, -217,    0,    0,    0,    0,    0,    0,
 -305, -247, -183,    0, -305,    0, -298,    0,    0,};
const short yyrindex[] =
	{                                      0,
    0,   83,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,  458,    0,    0,    1,    0,   67,
    0,  133,  199,    0,  266,    0,    0,    0,    0,    0,
    0,  332,  398,    0,    0,    0,    0,    0,    0,    0,
    0, -168,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,  -33,    0,    0,    0,    0,    0,
    0,    0,    0,  499,  519,  535,  552,  568,  585,  601,
  618,  634,  651,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0, -230,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,};
const short yygindex[] =
	{                                      0,
   -4,    0,    0,  -43,    0,    0,    0,  226,    0, -143,
    0,    0,    0,    0,    0,  -11,    0,   -9,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,   18,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,
};
#define YYTABLESIZE 955
const short yytable[] =
	{                                      42,
   31,  133,   58,  199,  165,   59,  173,  177,   57,  183,
  244,  128,   93,   45,   46,   34,   65,   97,   43,   72,
   48,   70,   71,  204,  205,   73,  123,  122,   77,   81,
  224,   83,   79,  168,   50,   54,   80,   88,   90,  227,
  228,   85,   95,  101,  206,  207,  208,  209,  210,  211,
   45,   46,  129,  102,  134,  106,  107,   45,   46,   34,
  114,  137,  140,  152,   34,  223,   25,   34,  235,   34,
   34,  203,   34,   34,  144,  241,  247,   34,  113,  122,
  122,   43,    1,   45,   46,  169,  170,  135,   40,  240,
  145,  146,  147,  148,  142,  143,  112,  116,    0,  149,
    0,  117,  118,    0,    0,    0,    0,    0,    0,    0,
    0,    0,  154,  155,  156,  157,  158,  159,  160,  161,
  162,  163,    0,    0,  164,    0,  166,    0,  119,  120,
  176,  121,  135,    0,  174,  179,  178,    0,    0,  122,
  123,  124,  125,  126,    0,    0,    0,  182,  184,  186,
  187,  188,  189,  190,  191,  192,  193,  194,  195,    0,
  200,  196,    0,    3,  197,  198,  202,    0,    0,    4,
    5,    6,  225,    0,    0,  212,    7,    8,    9,   10,
   11,   12,   13,   14,   15,   16,   17,   18,   19,   20,
   21,    0,    0,  229,    0,    0,    0,    0,  138,  231,
    0,    0,   22,   23,   24,   25,    0,    0,    0,  232,
    0,    0,   26,   27,  144,   28,   29,  237,  238,  234,
  239,   30,  214,  215,   31,   32,    0,   33,   34,    0,
  145,  146,  147,  148,   67,  249,  243,  245,    0,  151,
  248,    0,    0,  216,  217,  218,  219,  220,  221,    0,
   67,   67,   67,   67,    0,    0,   31,   29,    0,   67,
    0,    0,   31,   31,   31,   22,    0,    0,    0,   31,
   31,   31,   31,   31,   31,   31,   31,   31,   31,   31,
   31,   31,   31,   31,    0,    0,    0,   98,   99,  100,
    0,    0,  103,  104,  105,   31,   31,   31,   31,  108,
  109,  110,    0,    0,    0,   31,   31,    0,   31,   31,
    0,    0,    0,    0,   31,    0,    0,   31,   31,    0,
   31,   31,   25,   23,    0,    0,    0,    0,   25,   25,
   25,   57,    0,    0,    0,   25,   25,   25,   25,   25,
   25,   25,   25,   25,   25,   25,   25,   25,   25,   25,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,   25,   25,   25,   25,    0,    0,    0,    0,    0,
    0,   25,   25,    0,   25,   25,    0,    0,    0,    0,
   25,    0,    0,   25,   25,    0,   25,   25,  135,  136,
    0,    0,    0,    0,  135,  135,  135,   28,    0,    0,
    0,  135,  135,  135,  135,  135,  135,  135,  135,  135,
  135,  135,  135,  135,  135,  135,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,  135,  135,  135,
  135,    0,    0,    0,    0,    0,    0,  135,  135,    0,
  135,  135,    0,    0,    0,    0,  135,    0,    0,  135,
  135,    0,  135,  135,  138,  139,    0,   11,    0,    0,
  138,  138,  138,    0,    0,    0,    0,  138,  138,  138,
  138,  138,  138,  138,  138,  138,  138,  138,  138,  138,
  138,  138,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,  138,  138,  138,  138,    0,    0,    0,
    0,    0,    0,  138,  138,    0,  138,  138,    0,    0,
    0,    0,  138,    0,    0,  138,  138,    0,  138,  138,
    0,   22,   20,    0,    0,    0,    0,   22,   22,   22,
    0,    0,    0,    0,   22,   22,   22,   22,   22,   22,
   22,   22,   22,   22,   22,   22,   22,   22,   22,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
   22,   22,   22,   22,    0,    0,    0,    0,    0,    0,
   22,   22,    0,   22,   22,    0,    0,    0,    0,   22,
    0,    0,   22,   22,    0,   22,   22,   57,   55,    0,
    0,    0,    0,   57,   57,   57,    0,    0,    0,    0,
   57,   57,   57,   57,   57,   57,   57,   57,   57,   57,
   57,   57,   57,   57,   57,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,   57,   57,   57,   57,
    0,    0,    0,    0,    0,    0,   57,   57,    0,   57,
   57,    0,    0,    0,    0,   57,    0,    0,   57,   57,
    0,   57,   57,   28,   26,    0,    0,    0,    0,   28,
   28,   28,    0,    0,    0,    0,   28,   28,   28,   28,
   28,   28,   28,   28,   28,   28,   28,   28,   28,   28,
   28,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,   28,   28,   28,   28,    0,    0,    0,    0,
    0,    0,   28,   28,    0,   28,   28,    0,    0,    0,
    0,   28,    0,   11,   28,   28,    0,   28,   28,   11,
   11,   11,    0,    0,    0,    0,   11,   11,   11,   11,
   11,   11,   11,   11,   11,   11,   11,   11,   11,   11,
   11,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,   11,   11,   11,   11,  114,    0,    0,    0,
  114,  114,   11,   11,    0,   11,   11,    0,    0,    0,
    0,   11,    0,    0,   11,   11,  106,   11,   11,    0,
  106,  106,    0,    0,    0,    0,    0,  114,  114,    0,
  114,    0,  102,    0,    0,    0,  102,  102,  114,  114,
  114,  114,  114,    0,    0,    0,    0,  106,  106,  104,
  106,    0,    0,  104,  104,    0,    0,    0,  106,  106,
  106,  106,  106,  102,  102,  100,  102,    0,    0,  100,
  100,    0,    0,    0,  102,  102,  102,  102,  102,    0,
  104,  104,  108,  104,    0,    0,  108,  108,    0,    0,
    0,  104,  104,  104,  104,  104,  100,  100,  110,  100,
    0,    0,  110,  110,    0,    0,    0,  100,  100,  100,
  100,  100,    0,  108,  108,  112,  108,    0,    0,  112,
  112,    0,    0,    0,  108,  108,  108,  108,  108,  110,
  110,  116,  110,    0,    0,  116,  116,    0,    0,    0,
  110,  110,  110,  110,  110,    0,  112,  112,  118,  112,
    0,    0,  118,  118,    0,    0,    0,  112,  112,  112,
  112,  112,  116,  116,    0,  116,    0,    0,    0,    0,
    0,    0,    0,  116,  116,  116,  116,  116,    0,  118,
  118,    0,  118,    0,    0,    0,    0,    0,    0,    0,
  118,  118,  118,  118,  118,
};
const short yycheck[] =
	{                                       4,
    0,  258,   14,  258,  258,   15,  258,  258,   13,  258,
  258,  258,   56,  312,  313,  321,   21,   61,  307,   29,
  257,   26,   27,  267,  268,   30,  257,  258,  294,   41,
  259,  259,  294,  258,  257,  257,   41,  257,  257,  265,
  266,   46,  257,  315,  288,  289,  290,  291,  292,  293,
  312,  313,  299,  257,  311,  294,  294,  312,  313,  321,
  257,  257,  315,  293,  321,  260,    0,  321,  257,  321,
  321,  316,  321,  321,  268,  293,  260,  321,   83,  310,
  311,  307,    0,  312,  313,  310,  311,   92,  257,  233,
  284,  285,  286,  287,  106,  107,   79,  258,   -1,  293,
   -1,  262,  263,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,  117,  118,  119,  120,  121,  122,  123,  124,
  125,  126,   -1,   -1,  129,   -1,  131,   -1,  289,  290,
  140,  292,    0,   -1,  139,  145,  141,   -1,   -1,  300,
  301,  302,  303,  304,   -1,   -1,   -1,  152,  153,  154,
  155,  156,  157,  158,  159,  160,  161,  162,  163,   -1,
  172,  166,   -1,  256,  169,  170,  176,   -1,   -1,  262,
  263,  264,  184,   -1,   -1,  180,  269,  270,  271,  272,
  273,  274,  275,  276,  277,  278,  279,  280,  281,  282,
  283,   -1,   -1,  203,   -1,   -1,   -1,   -1,    0,  211,
   -1,   -1,  295,  296,  297,  298,   -1,   -1,   -1,  221,
   -1,   -1,  305,  306,  268,  308,  309,  227,  228,  224,
  230,  314,  267,  268,  317,  318,   -1,  320,  321,   -1,
  284,  285,  286,  287,  268,  247,  241,  242,   -1,  293,
  245,   -1,   -1,  288,  289,  290,  291,  292,  293,   -1,
  284,  285,  286,  287,   -1,   -1,  256,  257,   -1,  293,
   -1,   -1,  262,  263,  264,    0,   -1,   -1,   -1,  269,
  270,  271,  272,  273,  274,  275,  276,  277,  278,  279,
  280,  281,  282,  283,   -1,   -1,   -1,   62,   63,   64,
   -1,   -1,   67,   68,   69,  295,  296,  297,  298,   74,
   75,   76,   -1,   -1,   -1,  305,  306,   -1,  308,  309,
   -1,   -1,   -1,   -1,  314,   -1,   -1,  317,  318,   -1,
  320,  321,  256,  257,   -1,   -1,   -1,   -1,  262,  263,
  264,    0,   -1,   -1,   -1,  269,  270,  271,  272,  273,
  274,  275,  276,  277,  278,  279,  280,  281,  282,  283,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,  295,  296,  297,  298,   -1,   -1,   -1,   -1,   -1,
   -1,  305,  306,   -1,  308,  309,   -1,   -1,   -1,   -1,
  314,   -1,   -1,  317,  318,   -1,  320,  321,  256,  257,
   -1,   -1,   -1,   -1,  262,  263,  264,    0,   -1,   -1,
   -1,  269,  270,  271,  272,  273,  274,  275,  276,  277,
  278,  279,  280,  281,  282,  283,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,  295,  296,  297,
  298,   -1,   -1,   -1,   -1,   -1,   -1,  305,  306,   -1,
  308,  309,   -1,   -1,   -1,   -1,  314,   -1,   -1,  317,
  318,   -1,  320,  321,  256,  257,   -1,    0,   -1,   -1,
  262,  263,  264,   -1,   -1,   -1,   -1,  269,  270,  271,
  272,  273,  274,  275,  276,  277,  278,  279,  280,  281,
  282,  283,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,  295,  296,  297,  298,   -1,   -1,   -1,
   -1,   -1,   -1,  305,  306,   -1,  308,  309,   -1,   -1,
   -1,   -1,  314,   -1,   -1,  317,  318,   -1,  320,  321,
   -1,  256,  257,   -1,   -1,   -1,   -1,  262,  263,  264,
   -1,   -1,   -1,   -1,  269,  270,  271,  272,  273,  274,
  275,  276,  277,  278,  279,  280,  281,  282,  283,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
  295,  296,  297,  298,   -1,   -1,   -1,   -1,   -1,   -1,
  305,  306,   -1,  308,  309,   -1,   -1,   -1,   -1,  314,
   -1,   -1,  317,  318,   -1,  320,  321,  256,  257,   -1,
   -1,   -1,   -1,  262,  263,  264,   -1,   -1,   -1,   -1,
  269,  270,  271,  272,  273,  274,  275,  276,  277,  278,
  279,  280,  281,  282,  283,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,  295,  296,  297,  298,
   -1,   -1,   -1,   -1,   -1,   -1,  305,  306,   -1,  308,
  309,   -1,   -1,   -1,   -1,  314,   -1,   -1,  317,  318,
   -1,  320,  321,  256,  257,   -1,   -1,   -1,   -1,  262,
  263,  264,   -1,   -1,   -1,   -1,  269,  270,  271,  272,
  273,  274,  275,  276,  277,  278,  279,  280,  281,  282,
  283,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,  295,  296,  297,  298,   -1,   -1,   -1,   -1,
   -1,   -1,  305,  306,   -1,  308,  309,   -1,   -1,   -1,
   -1,  314,   -1,  256,  317,  318,   -1,  320,  321,  262,
  263,  264,   -1,   -1,   -1,   -1,  269,  270,  271,  272,
  273,  274,  275,  276,  277,  278,  279,  280,  281,  282,
  283,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,  295,  296,  297,  298,  258,   -1,   -1,   -1,
  262,  263,  305,  306,   -1,  308,  309,   -1,   -1,   -1,
   -1,  314,   -1,   -1,  317,  318,  258,  320,  321,   -1,
  262,  263,   -1,   -1,   -1,   -1,   -1,  289,  290,   -1,
  292,   -1,  258,   -1,   -1,   -1,  262,  263,  300,  301,
  302,  303,  304,   -1,   -1,   -1,   -1,  289,  290,  258,
  292,   -1,   -1,  262,  263,   -1,   -1,   -1,  300,  301,
  302,  303,  304,  289,  290,  258,  292,   -1,   -1,  262,
  263,   -1,   -1,   -1,  300,  301,  302,  303,  304,   -1,
  289,  290,  258,  292,   -1,   -1,  262,  263,   -1,   -1,
   -1,  300,  301,  302,  303,  304,  289,  290,  258,  292,
   -1,   -1,  262,  263,   -1,   -1,   -1,  300,  301,  302,
  303,  304,   -1,  289,  290,  258,  292,   -1,   -1,  262,
  263,   -1,   -1,   -1,  300,  301,  302,  303,  304,  289,
  290,  258,  292,   -1,   -1,  262,  263,   -1,   -1,   -1,
  300,  301,  302,  303,  304,   -1,  289,  290,  258,  292,
   -1,   -1,  262,  263,   -1,   -1,   -1,  300,  301,  302,
  303,  304,  289,  290,   -1,  292,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,  300,  301,  302,  303,  304,   -1,  289,
  290,   -1,  292,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
  300,  301,  302,  303,  304,
};
#define YYFINAL 1
#ifndef YYDEBUG
#define YYDEBUG 0
#endif
#define YYMAXTOKEN 321
#if YYDEBUG
const char * const yyname[] =
	{
"end-of-file",0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,"LB","RB","LP","RP","MENUS",
"MENU","BUTTON","DEFAULT_FUNCTION","PLUS","MINUS","ALL","OR","CURSORS",
"PIXMAPS","ICONS","COLOR","SAVECOLOR","MONOCHROME","FUNCTION","WINDOW_FUNCTION",
"ZOOM","MAKE_TITLE","GRAYSCALE","NO_TITLE","AUTO_RAISE","NO_HILITE",
"ICON_REGION","META","SHIFT","LOCK","CONTROL","WINDOW","TITLE","ICON","ROOT",
"FRAME","COLON","EQUALS","SQUEEZE_TITLE","DONT_SQUEEZE_TITLE","START_ICONIFIED",
"NO_TITLE_HILITE","TITLE_HILITE","MOVE","RESIZE","WAIT","SELECT","KILL",
"LEFT_TITLEBUTTON","RIGHT_TITLEBUTTON","NUMBER","KEYWORD","NKEYWORD","CKEYWORD",
"CLKEYWORD","FKEYWORD","FSKEYWORD","SKEYWORD","DKEYWORD","JKEYWORD",
"WINDOW_RING","WARP_CURSOR","ERRORTOKEN","NO_STACKMODE","STRING",
};
const char * const yyrule[] =
	{"$accept : twmrc",
"twmrc : stmts",
"stmts :",
"stmts : stmts stmt",
"stmt : error",
"stmt : noarg",
"stmt : sarg",
"stmt : narg",
"stmt : squeeze",
"stmt : ICON_REGION string DKEYWORD DKEYWORD number number",
"stmt : ZOOM number",
"stmt : ZOOM",
"stmt : PIXMAPS pixmap_list",
"stmt : CURSORS cursor_list",
"stmt : LEFT_TITLEBUTTON string EQUALS action",
"stmt : RIGHT_TITLEBUTTON string EQUALS action",
"stmt : button string",
"stmt : button action",
"stmt : string fullkey",
"stmt : button full",
"$$1 :",
"stmt : NO_TITLE_HILITE $$1 win_list",
"stmt : NO_TITLE_HILITE",
"$$2 :",
"stmt : NO_HILITE $$2 win_list",
"stmt : NO_HILITE",
"$$3 :",
"stmt : NO_STACKMODE $$3 win_list",
"stmt : NO_STACKMODE",
"$$4 :",
"stmt : NO_TITLE $$4 win_list",
"stmt : NO_TITLE",
"$$5 :",
"stmt : MAKE_TITLE $$5 win_list",
"$$6 :",
"stmt : START_ICONIFIED $$6 win_list",
"$$7 :",
"stmt : AUTO_RAISE $$7 win_list",
"$$8 :",
"stmt : MENU string LP string COLON string RP $$8 menu",
"$$9 :",
"stmt : MENU string $$9 menu",
"$$10 :",
"stmt : FUNCTION string $$10 function",
"$$11 :",
"stmt : ICONS $$11 icon_list",
"$$12 :",
"stmt : COLOR $$12 color_list",
"$$13 :",
"stmt : GRAYSCALE $$13 color_list",
"stmt : SAVECOLOR save_color_list",
"$$14 :",
"stmt : MONOCHROME $$14 color_list",
"stmt : DEFAULT_FUNCTION action",
"stmt : WINDOW_FUNCTION action",
"$$15 :",
"stmt : WARP_CURSOR $$15 win_list",
"stmt : WARP_CURSOR",
"$$16 :",
"stmt : WINDOW_RING $$16 win_list",
"noarg : KEYWORD",
"sarg : SKEYWORD string",
"narg : NKEYWORD number",
"full : EQUALS keys COLON contexts COLON action",
"fullkey : EQUALS keys COLON contextkeys COLON action",
"keys :",
"keys : keys key",
"key : META",
"key : SHIFT",
"key : LOCK",
"key : CONTROL",
"key : META number",
"key : OR",
"contexts :",
"contexts : contexts context",
"context : WINDOW",
"context : TITLE",
"context : ICON",
"context : ROOT",
"context : FRAME",
"context : ALL",
"context : OR",
"contextkeys :",
"contextkeys : contextkeys contextkey",
"contextkey : WINDOW",
"contextkey : TITLE",
"contextkey : ICON",
"contextkey : ROOT",
"contextkey : FRAME",
"contextkey : ALL",
"contextkey : OR",
"contextkey : string",
"pixmap_list : LB pixmap_entries RB",
"pixmap_entries :",
"pixmap_entries : pixmap_entries pixmap_entry",
"pixmap_entry : TITLE_HILITE string",
"cursor_list : LB cursor_entries RB",
"cursor_entries :",
"cursor_entries : cursor_entries cursor_entry",
"cursor_entry : FRAME string string",
"cursor_entry : FRAME string",
"cursor_entry : TITLE string string",
"cursor_entry : TITLE string",
"cursor_entry : ICON string string",
"cursor_entry : ICON string",
"cursor_entry : BUTTON string string",
"cursor_entry : BUTTON string",
"cursor_entry : MOVE string string",
"cursor_entry : MOVE string",
"cursor_entry : RESIZE string string",
"cursor_entry : RESIZE string",
"cursor_entry : WAIT string string",
"cursor_entry : WAIT string",
"cursor_entry : MENU string string",
"cursor_entry : MENU string",
"cursor_entry : SELECT string string",
"cursor_entry : SELECT string",
"cursor_entry : KILL string string",
"cursor_entry : KILL string",
"color_list : LB color_entries RB",
"color_entries :",
"color_entries : color_entries color_entry",
"color_entry : CLKEYWORD string",
"$$17 :",
"color_entry : CLKEYWORD string $$17 win_color_list",
"color_entry : CKEYWORD string",
"save_color_list : LB s_color_entries RB",
"s_color_entries :",
"s_color_entries : s_color_entries s_color_entry",
"s_color_entry : string",
"s_color_entry : CLKEYWORD",
"win_color_list : LB win_color_entries RB",
"win_color_entries :",
"win_color_entries : win_color_entries win_color_entry",
"win_color_entry : string string",
"squeeze : SQUEEZE_TITLE",
"$$18 :",
"squeeze : SQUEEZE_TITLE $$18 LB win_sqz_entries RB",
"squeeze : DONT_SQUEEZE_TITLE",
"$$19 :",
"squeeze : DONT_SQUEEZE_TITLE $$19 win_list",
"win_sqz_entries :",
"win_sqz_entries : win_sqz_entries string JKEYWORD signed_number number",
"win_list : LB win_entries RB",
"win_entries :",
"win_entries : win_entries win_entry",
"win_entry : string",
"icon_list : LB icon_entries RB",
"icon_entries :",
"icon_entries : icon_entries icon_entry",
"icon_entry : string string",
"function : LB function_entries RB",
"function_entries :",
"function_entries : function_entries function_entry",
"function_entry : action",
"menu : LB menu_entries RB",
"menu_entries :",
"menu_entries : menu_entries menu_entry",
"menu_entry : string action",
"menu_entry : string LP string COLON string RP action",
"action : FKEYWORD",
"action : FSKEYWORD string",
"signed_number : number",
"signed_number : PLUS number",
"signed_number : MINUS number",
"button : BUTTON number",
"string : STRING",
"number : NUMBER",
};
#endif
#ifdef YYSTACKSIZE
#undef YYMAXDEPTH
#define YYMAXDEPTH YYSTACKSIZE
#else
#ifdef YYMAXDEPTH
#define YYSTACKSIZE YYMAXDEPTH
#else
#define YYSTACKSIZE 10000
#define YYMAXDEPTH 10000
#endif
#endif
#define YYINITSTACKSIZE 200
/* LINTUSED */
int yydebug;
int yynerrs;
int yyerrflag;
int yychar;
short *yyssp;
YYSTYPE *yyvsp;
YYSTYPE yyval;
YYSTYPE yylval;
short *yyss;
short *yysslim;
YYSTYPE *yyvs;
unsigned int yystacksize;
int yyparse(void);
#line 612 "gram.y"
static void
yyerror(const char *s)
{
    twmrc_error_prefix();
    fprintf (stderr, "error in input file:  %s\n", s ? s : "");
    ParseError = 1;
}

static void
RemoveDQuote(char *str)
{
    register char *i, *o;
    register int n;
    register int count;

    for (i=str+1, o=str; *i && *i != '\"'; o++)
    {
	if (*i == '\\')
	{
	    switch (*++i)
	    {
	    case 'n':
		*o = '\n';
		i++;
		break;
	    case 'b':
		*o = '\b';
		i++;
		break;
	    case 'r':
		*o = '\r';
		i++;
		break;
	    case 't':
		*o = '\t';
		i++;
		break;
	    case 'f':
		*o = '\f';
		i++;
		break;
	    case '0':
		if (*++i == 'x')
		    goto hex;
		else
		    --i;
	    case '1': case '2': case '3':
	    case '4': case '5': case '6': case '7':
		n = 0;
		count = 0;
		while (*i >= '0' && *i <= '7' && count < 3)
		{
		    n = (n<<3) + (*i++ - '0');
		    count++;
		}
		*o = n;
		break;
	    hex:
	    case 'x':
		n = 0;
		count = 0;
		while (i++, count++ < 2)
		{
		    if (*i >= '0' && *i <= '9')
			n = (n<<4) + (*i - '0');
		    else if (*i >= 'a' && *i <= 'f')
			n = (n<<4) + (*i - 'a') + 10;
		    else if (*i >= 'A' && *i <= 'F')
			n = (n<<4) + (*i - 'A') + 10;
		    else
			break;
		}
		*o = n;
		break;
	    case '\n':
		i++;	/* punt */
		o--;	/* to account for o++ at end of loop */
		break;
	    case '\"':
	    case '\'':
	    case '\\':
	    default:
		*o = *i++;
		break;
	    }
	}
	else
	    *o = *i++;
    }
    *o = '\0';
}

static MenuRoot *GetRoot(const char *name, const char* fore, const char *back)
{
    MenuRoot *tmp;

    tmp = FindMenuRoot(name);
    if (tmp == NULL)
	tmp = NewMenuRoot(name);

    if (fore)
    {
	int save;

	save = Scr->FirstTime;
	Scr->FirstTime = TRUE;
	GetColor(COLOR, &tmp->hi_fore, fore);
	GetColor(COLOR, &tmp->hi_back, back);
	Scr->FirstTime = save;
    }

    return tmp;
}

static void GotButton(int butt, int func)
{
    int i;

    for (i = 0; i < NUM_CONTEXTS; i++)
    {
	if ((cont & (1 << i)) == 0)
	    continue;

	Scr->Mouse[butt][i][mods].func = func;
	if (func == F_MENU)
	{
	    pull->prev = NULL;
	    Scr->Mouse[butt][i][mods].menu = pull;
	}
	else
	{
	    root = GetRoot(TWM_ROOT, NULLSTR, NULLSTR);
	    Scr->Mouse[butt][i][mods].item = AddToMenu(root,"x",Action,
		    NULL, func, NULLSTR, NULLSTR);
	}
    }
    Action = "";
    pull = NULL;
    cont = 0;
    mods_used |= mods;
    mods = 0;
}

static void GotKey(char *key, int func)
{
    int i;

    for (i = 0; i < NUM_CONTEXTS; i++)
    {
	if ((cont & (1 << i)) == 0)
	  continue;
	if (!AddFuncKey(key, i, mods, func, Name, Action))
	  break;
    }

    Action = "";
    pull = NULL;
    cont = 0;
    mods_used |= mods;
    mods = 0;
}


static void GotTitleButton (char *bitmapname, int func, Bool rightside)
{
    if (!CreateTitleButton (bitmapname, func, Action, pull, rightside, True)) {
	twmrc_error_prefix();
	fprintf (stderr,
		 "unable to create %s titlebutton \"%s\"\n",
		 rightside ? "right" : "left", bitmapname);
    }
    Action = "";
    pull = NULL;
}

static Bool CheckWarpScreenArg (char *s)
{
    XmuCopyISOLatin1Lowered (s, s);

    if (strcmp (s,  WARPSCREEN_NEXT) == 0 ||
	strcmp (s,  WARPSCREEN_PREV) == 0 ||
	strcmp (s,  WARPSCREEN_BACK) == 0)
      return True;

    for (; *s && isascii(*s) && isdigit(*s); s++) ; /* SUPPRESS 530 */
    return (*s ? False : True);
}


static Bool CheckWarpRingArg (char *s)
{
    XmuCopyISOLatin1Lowered (s, s);

    if (strcmp (s,  WARPSCREEN_NEXT) == 0 ||
	strcmp (s,  WARPSCREEN_PREV) == 0)
      return True;

    return False;
}


static Bool CheckColormapArg (char *s)
{
    XmuCopyISOLatin1Lowered (s, s);

    if (strcmp (s, COLORMAP_NEXT) == 0 ||
	strcmp (s, COLORMAP_PREV) == 0 ||
	strcmp (s, COLORMAP_DEFAULT) == 0)
      return True;

    return False;
}


void
twmrc_error_prefix (void)
{
    fprintf (stderr, "%s:  line %d:  ", ProgramName, yylineno);
}
#line 901 "gram.c"
/* allocate initial stack or double stack size, up to YYMAXDEPTH */
static int yygrowstack(void)
{
    unsigned int newsize;
    long sslen;
    short *newss;
    YYSTYPE *newvs;

    if ((newsize = yystacksize) == 0)
        newsize = YYINITSTACKSIZE;
    else if (newsize >= YYMAXDEPTH)
        return -1;
    else if ((newsize *= 2) > YYMAXDEPTH)
        newsize = YYMAXDEPTH;
    sslen = yyssp - yyss;
#ifdef SIZE_MAX
#define YY_SIZE_MAX SIZE_MAX
#else
#define YY_SIZE_MAX 0xffffffffU
#endif
    if (newsize && YY_SIZE_MAX / newsize < sizeof *newss)
        goto bail;
    newss = yyss ? (short *)realloc(yyss, newsize * sizeof *newss) :
      (short *)malloc(newsize * sizeof *newss); /* overflow check above */
    if (newss == NULL)
        goto bail;
    yyss = newss;
    yyssp = newss + sslen;
    if (newsize && YY_SIZE_MAX / newsize < sizeof *newvs)
        goto bail;
    newvs = yyvs ? (YYSTYPE *)realloc(yyvs, newsize * sizeof *newvs) :
      (YYSTYPE *)malloc(newsize * sizeof *newvs); /* overflow check above */
    if (newvs == NULL)
        goto bail;
    yyvs = newvs;
    yyvsp = newvs + sslen;
    yystacksize = newsize;
    yysslim = yyss + newsize - 1;
    return 0;
bail:
    if (yyss)
            free(yyss);
    if (yyvs)
            free(yyvs);
    yyss = yyssp = NULL;
    yyvs = yyvsp = NULL;
    yystacksize = 0;
    return -1;
}

#define YYABORT goto yyabort
#define YYREJECT goto yyabort
#define YYACCEPT goto yyaccept
#define YYERROR goto yyerrlab
int
yyparse(void)
{
    int yym, yyn, yystate;
#if YYDEBUG
    const char *yys;

    if ((yys = getenv("YYDEBUG")))
    {
        yyn = *yys;
        if (yyn >= '0' && yyn <= '9')
            yydebug = yyn - '0';
    }
#endif /* YYDEBUG */

    yynerrs = 0;
    yyerrflag = 0;
    yychar = (-1);

    if (yyss == NULL && yygrowstack()) goto yyoverflow;
    yyssp = yyss;
    yyvsp = yyvs;
    *yyssp = yystate = 0;

yyloop:
    if ((yyn = yydefred[yystate]) != 0) goto yyreduce;
    if (yychar < 0)
    {
        if ((yychar = yylex()) < 0) yychar = 0;
#if YYDEBUG
        if (yydebug)
        {
            yys = 0;
            if (yychar <= YYMAXTOKEN) yys = yyname[yychar];
            if (!yys) yys = "illegal-symbol";
            printf("%sdebug: state %d, reading %d (%s)\n",
                    YYPREFIX, yystate, yychar, yys);
        }
#endif
    }
    if ((yyn = yysindex[yystate]) && (yyn += yychar) >= 0 &&
            yyn <= YYTABLESIZE && yycheck[yyn] == yychar)
    {
#if YYDEBUG
        if (yydebug)
            printf("%sdebug: state %d, shifting to state %d\n",
                    YYPREFIX, yystate, yytable[yyn]);
#endif
        if (yyssp >= yysslim && yygrowstack())
        {
            goto yyoverflow;
        }
        *++yyssp = yystate = yytable[yyn];
        *++yyvsp = yylval;
        yychar = (-1);
        if (yyerrflag > 0)  --yyerrflag;
        goto yyloop;
    }
    if ((yyn = yyrindex[yystate]) && (yyn += yychar) >= 0 &&
            yyn <= YYTABLESIZE && yycheck[yyn] == yychar)
    {
        yyn = yytable[yyn];
        goto yyreduce;
    }
    if (yyerrflag) goto yyinrecovery;
#if defined(__GNUC__)
    goto yynewerror;
#endif
yynewerror:
    yyerror("syntax error");
#if defined(__GNUC__)
    goto yyerrlab;
#endif
yyerrlab:
    ++yynerrs;
yyinrecovery:
    if (yyerrflag < 3)
    {
        yyerrflag = 3;
        for (;;)
        {
            if ((yyn = yysindex[*yyssp]) && (yyn += YYERRCODE) >= 0 &&
                    yyn <= YYTABLESIZE && yycheck[yyn] == YYERRCODE)
            {
#if YYDEBUG
                if (yydebug)
                    printf("%sdebug: state %d, error recovery shifting\
 to state %d\n", YYPREFIX, *yyssp, yytable[yyn]);
#endif
                if (yyssp >= yysslim && yygrowstack())
                {
                    goto yyoverflow;
                }
                *++yyssp = yystate = yytable[yyn];
                *++yyvsp = yylval;
                goto yyloop;
            }
            else
            {
#if YYDEBUG
                if (yydebug)
                    printf("%sdebug: error recovery discarding state %d\n",
                            YYPREFIX, *yyssp);
#endif
                if (yyssp <= yyss) goto yyabort;
                --yyssp;
                --yyvsp;
            }
        }
    }
    else
    {
        if (yychar == 0) goto yyabort;
#if YYDEBUG
        if (yydebug)
        {
            yys = 0;
            if (yychar <= YYMAXTOKEN) yys = yyname[yychar];
            if (!yys) yys = "illegal-symbol";
            printf("%sdebug: state %d, error recovery discards token %d (%s)\n",
                    YYPREFIX, yystate, yychar, yys);
        }
#endif
        yychar = (-1);
        goto yyloop;
    }
yyreduce:
#if YYDEBUG
    if (yydebug)
        printf("%sdebug: state %d, reducing by rule %d (%s)\n",
                YYPREFIX, yystate, yyn, yyrule[yyn]);
#endif
    yym = yylen[yyn];
    if (yym)
        yyval = yyvsp[1-yym];
    else
        memset(&yyval, 0, sizeof yyval);
    switch (yyn)
    {
case 9:
#line 148 "gram.y"
{ AddIconRegion(yyvsp[-4].ptr, yyvsp[-3].num, yyvsp[-2].num, yyvsp[-1].num, yyvsp[0].num); }
break;
case 10:
#line 149 "gram.y"
{ if (Scr->FirstTime)
					  {
						Scr->DoZoom = TRUE;
						Scr->ZoomCount = yyvsp[0].num;
					  }
					}
break;
case 11:
#line 155 "gram.y"
{ if (Scr->FirstTime)
						Scr->DoZoom = TRUE; }
break;
case 12:
#line 157 "gram.y"
{}
break;
case 13:
#line 158 "gram.y"
{}
break;
case 14:
#line 159 "gram.y"
{
					  GotTitleButton (yyvsp[-2].ptr, yyvsp[0].num, False);
					}
break;
case 15:
#line 162 "gram.y"
{
					  GotTitleButton (yyvsp[-2].ptr, yyvsp[0].num, True);
					}
break;
case 16:
#line 165 "gram.y"
{ root = GetRoot(yyvsp[0].ptr, NULLSTR, NULLSTR);
					  Scr->Mouse[yyvsp[-1].num][C_ROOT][0].func = F_MENU;
					  Scr->Mouse[yyvsp[-1].num][C_ROOT][0].menu = root;
					}
break;
case 17:
#line 169 "gram.y"
{ Scr->Mouse[yyvsp[-1].num][C_ROOT][0].func = yyvsp[0].num;
					  if (yyvsp[0].num == F_MENU)
					  {
					    pull->prev = NULL;
					    Scr->Mouse[yyvsp[-1].num][C_ROOT][0].menu = pull;
					  }
					  else
					  {
					    root = GetRoot(TWM_ROOT,NULLSTR,NULLSTR);
					    Scr->Mouse[yyvsp[-1].num][C_ROOT][0].item =
						AddToMenu(root,"x",Action,
							  NULL,yyvsp[0].num,NULLSTR,NULLSTR);
					  }
					  Action = "";
					  pull = NULL;
					}
break;
case 18:
#line 185 "gram.y"
{ GotKey(yyvsp[-1].ptr, yyvsp[0].num); }
break;
case 19:
#line 186 "gram.y"
{ GotButton(yyvsp[-1].num, yyvsp[0].num); }
break;
case 20:
#line 187 "gram.y"
{ list = &Scr->NoTitleHighlight; }
break;
case 22:
#line 189 "gram.y"
{ if (Scr->FirstTime)
						Scr->TitleHighlight = FALSE; }
break;
case 23:
#line 191 "gram.y"
{ list = &Scr->NoHighlight; }
break;
case 25:
#line 193 "gram.y"
{ if (Scr->FirstTime)
						Scr->Highlight = FALSE; }
break;
case 26:
#line 195 "gram.y"
{ list = &Scr->NoStackModeL; }
break;
case 28:
#line 197 "gram.y"
{ if (Scr->FirstTime)
						Scr->StackMode = FALSE; }
break;
case 29:
#line 199 "gram.y"
{ list = &Scr->NoTitle; }
break;
case 31:
#line 201 "gram.y"
{ if (Scr->FirstTime)
						Scr->NoTitlebar = TRUE; }
break;
case 32:
#line 203 "gram.y"
{ list = &Scr->MakeTitle; }
break;
case 34:
#line 205 "gram.y"
{ list = &Scr->StartIconified; }
break;
case 36:
#line 207 "gram.y"
{ list = &Scr->AutoRaise; }
break;
case 38:
#line 209 "gram.y"
{
					root = GetRoot(yyvsp[-5].ptr, yyvsp[-3].ptr, yyvsp[-1].ptr); }
break;
case 39:
#line 211 "gram.y"
{ root->real_menu = TRUE;}
break;
case 40:
#line 212 "gram.y"
{ root = GetRoot(yyvsp[0].ptr, NULLSTR, NULLSTR); }
break;
case 41:
#line 213 "gram.y"
{ root->real_menu = TRUE; }
break;
case 42:
#line 214 "gram.y"
{ root = GetRoot(yyvsp[0].ptr, NULLSTR, NULLSTR); }
break;
case 44:
#line 216 "gram.y"
{ list = &Scr->IconNames; }
break;
case 46:
#line 218 "gram.y"
{ color = COLOR; }
break;
case 48:
#line 220 "gram.y"
{ color = GRAYSCALE; }
break;
case 51:
#line 224 "gram.y"
{ color = MONOCHROME; }
break;
case 53:
#line 226 "gram.y"
{ Scr->DefaultFunction.func = yyvsp[0].num;
					  if (yyvsp[0].num == F_MENU)
					  {
					    pull->prev = NULL;
					    Scr->DefaultFunction.menu = pull;
					  }
					  else
					  {
					    root = GetRoot(TWM_ROOT,NULLSTR,NULLSTR);
					    Scr->DefaultFunction.item =
						AddToMenu(root,"x",Action,
							  NULL,yyvsp[0].num, NULLSTR, NULLSTR);
					  }
					  Action = "";
					  pull = NULL;
					}
break;
case 54:
#line 242 "gram.y"
{ Scr->WindowFunction.func = yyvsp[0].num;
					   root = GetRoot(TWM_ROOT,NULLSTR,NULLSTR);
					   Scr->WindowFunction.item =
						AddToMenu(root,"x",Action,
							  NULL,yyvsp[0].num, NULLSTR, NULLSTR);
					   Action = "";
					   pull = NULL;
					}
break;
case 55:
#line 250 "gram.y"
{ list = &Scr->WarpCursorL; }
break;
case 57:
#line 252 "gram.y"
{ if (Scr->FirstTime)
					    Scr->WarpCursor = TRUE; }
break;
case 58:
#line 254 "gram.y"
{ list = &Scr->WindowRingL; }
break;
case 60:
#line 259 "gram.y"
{ if (!do_single_keyword (yyvsp[0].num)) {
					    twmrc_error_prefix();
					    fprintf (stderr,
					"unknown singleton keyword %d\n",
						     yyvsp[0].num);
					    ParseError = 1;
					  }
					}
break;
case 61:
#line 269 "gram.y"
{ if (!do_string_keyword (yyvsp[-1].num, yyvsp[0].ptr)) {
					    twmrc_error_prefix();
					    fprintf (stderr,
				"unknown string keyword %d (value \"%s\")\n",
						     yyvsp[-1].num, yyvsp[0].ptr);
					    ParseError = 1;
					  }
					}
break;
case 62:
#line 279 "gram.y"
{ if (!do_number_keyword (yyvsp[-1].num, yyvsp[0].num)) {
					    twmrc_error_prefix();
					    fprintf (stderr,
				"unknown numeric keyword %d (value %d)\n",
						     yyvsp[-1].num, yyvsp[0].num);
					    ParseError = 1;
					  }
					}
break;
case 63:
#line 291 "gram.y"
{ yyval.num = yyvsp[0].num; }
break;
case 64:
#line 294 "gram.y"
{ yyval.num = yyvsp[0].num; }
break;
case 67:
#line 301 "gram.y"
{ mods |= Mod1Mask; }
break;
case 68:
#line 302 "gram.y"
{ mods |= ShiftMask; }
break;
case 69:
#line 303 "gram.y"
{ mods |= LockMask; }
break;
case 70:
#line 304 "gram.y"
{ mods |= ControlMask; }
break;
case 71:
#line 305 "gram.y"
{ if (yyvsp[0].num < 1 || yyvsp[0].num > 5) {
					     twmrc_error_prefix();
					     fprintf (stderr,
				"bad modifier number (%d), must be 1-5\n",
						      yyvsp[0].num);
					     ParseError = 1;
					  } else {
					     mods |= (Mod1Mask << (yyvsp[0].num - 1));
					  }
					}
break;
case 72:
#line 315 "gram.y"
{ }
break;
case 75:
#line 322 "gram.y"
{ cont |= C_WINDOW_BIT; }
break;
case 76:
#line 323 "gram.y"
{ cont |= C_TITLE_BIT; }
break;
case 77:
#line 324 "gram.y"
{ cont |= C_ICON_BIT; }
break;
case 78:
#line 325 "gram.y"
{ cont |= C_ROOT_BIT; }
break;
case 79:
#line 326 "gram.y"
{ cont |= C_FRAME_BIT; }
break;
case 80:
#line 327 "gram.y"
{ cont |= C_ALL_BITS; }
break;
case 81:
#line 328 "gram.y"
{  }
break;
case 84:
#line 335 "gram.y"
{ cont |= C_WINDOW_BIT; }
break;
case 85:
#line 336 "gram.y"
{ cont |= C_TITLE_BIT; }
break;
case 86:
#line 337 "gram.y"
{ cont |= C_ICON_BIT; }
break;
case 87:
#line 338 "gram.y"
{ cont |= C_ROOT_BIT; }
break;
case 88:
#line 339 "gram.y"
{ cont |= C_FRAME_BIT; }
break;
case 89:
#line 340 "gram.y"
{ cont |= C_ALL_BITS; }
break;
case 90:
#line 341 "gram.y"
{ }
break;
case 91:
#line 342 "gram.y"
{ Name = yyvsp[0].ptr; cont |= C_NAME_BIT; }
break;
case 95:
#line 353 "gram.y"
{ SetHighlightPixmap (yyvsp[0].ptr); }
break;
case 99:
#line 364 "gram.y"
{
			NewBitmapCursor(&Scr->FrameCursor, yyvsp[-1].ptr, yyvsp[0].ptr); }
break;
case 100:
#line 366 "gram.y"
{
			NewFontCursor(&Scr->FrameCursor, yyvsp[0].ptr); }
break;
case 101:
#line 368 "gram.y"
{
			NewBitmapCursor(&Scr->TitleCursor, yyvsp[-1].ptr, yyvsp[0].ptr); }
break;
case 102:
#line 370 "gram.y"
{
			NewFontCursor(&Scr->TitleCursor, yyvsp[0].ptr); }
break;
case 103:
#line 372 "gram.y"
{
			NewBitmapCursor(&Scr->IconCursor, yyvsp[-1].ptr, yyvsp[0].ptr); }
break;
case 104:
#line 374 "gram.y"
{
			NewFontCursor(&Scr->IconCursor, yyvsp[0].ptr); }
break;
case 105:
#line 376 "gram.y"
{
			NewBitmapCursor(&Scr->ButtonCursor, yyvsp[-1].ptr, yyvsp[0].ptr); }
break;
case 106:
#line 378 "gram.y"
{
			NewFontCursor(&Scr->ButtonCursor, yyvsp[0].ptr); }
break;
case 107:
#line 380 "gram.y"
{
			NewBitmapCursor(&Scr->MoveCursor, yyvsp[-1].ptr, yyvsp[0].ptr); }
break;
case 108:
#line 382 "gram.y"
{
			NewFontCursor(&Scr->MoveCursor, yyvsp[0].ptr); }
break;
case 109:
#line 384 "gram.y"
{
			NewBitmapCursor(&Scr->ResizeCursor, yyvsp[-1].ptr, yyvsp[0].ptr); }
break;
case 110:
#line 386 "gram.y"
{
			NewFontCursor(&Scr->ResizeCursor, yyvsp[0].ptr); }
break;
case 111:
#line 388 "gram.y"
{
			NewBitmapCursor(&Scr->WaitCursor, yyvsp[-1].ptr, yyvsp[0].ptr); }
break;
case 112:
#line 390 "gram.y"
{
			NewFontCursor(&Scr->WaitCursor, yyvsp[0].ptr); }
break;
case 113:
#line 392 "gram.y"
{
			NewBitmapCursor(&Scr->MenuCursor, yyvsp[-1].ptr, yyvsp[0].ptr); }
break;
case 114:
#line 394 "gram.y"
{
			NewFontCursor(&Scr->MenuCursor, yyvsp[0].ptr); }
break;
case 115:
#line 396 "gram.y"
{
			NewBitmapCursor(&Scr->SelectCursor, yyvsp[-1].ptr, yyvsp[0].ptr); }
break;
case 116:
#line 398 "gram.y"
{
			NewFontCursor(&Scr->SelectCursor, yyvsp[0].ptr); }
break;
case 117:
#line 400 "gram.y"
{
			NewBitmapCursor(&Scr->DestroyCursor, yyvsp[-1].ptr, yyvsp[0].ptr); }
break;
case 118:
#line 402 "gram.y"
{
			NewFontCursor(&Scr->DestroyCursor, yyvsp[0].ptr); }
break;
case 122:
#line 414 "gram.y"
{ if (!do_colorlist_keyword (yyvsp[-1].num, color,
								     yyvsp[0].ptr)) {
					    twmrc_error_prefix();
					    fprintf (stderr,
			"unhandled list color keyword %d (string \"%s\")\n",
						     yyvsp[-1].num, yyvsp[0].ptr);
					    ParseError = 1;
					  }
					}
break;
case 123:
#line 423 "gram.y"
{ list = do_colorlist_keyword(yyvsp[-1].num,color,
								      yyvsp[0].ptr);
					  if (!list) {
					    twmrc_error_prefix();
					    fprintf (stderr,
			"unhandled color list keyword %d (string \"%s\")\n",
						     yyvsp[-1].num, yyvsp[0].ptr);
					    ParseError = 1;
					  }
					}
break;
case 124:
#line 433 "gram.y"
{ /* No action */; }
break;
case 125:
#line 434 "gram.y"
{ if (!do_color_keyword (yyvsp[-1].num, color,
								 yyvsp[0].ptr)) {
					    twmrc_error_prefix();
					    fprintf (stderr,
			"unhandled color keyword %d (string \"%s\")\n",
						     yyvsp[-1].num, yyvsp[0].ptr);
					    ParseError = 1;
					  }
					}
break;
case 129:
#line 452 "gram.y"
{ do_string_savecolor(color, yyvsp[0].ptr); }
break;
case 130:
#line 453 "gram.y"
{ do_var_savecolor(yyvsp[0].num); }
break;
case 134:
#line 463 "gram.y"
{ if (Scr->FirstTime &&
					      color == Scr->Monochrome)
					    AddToList(list, yyvsp[-1].ptr, yyvsp[0].ptr); }
break;
case 135:
#line 468 "gram.y"
{
				    if (HasShape) Scr->SqueezeTitle = TRUE;
				}
break;
case 136:
#line 471 "gram.y"
{ list = &Scr->SqueezeTitleL;
				  if (HasShape && Scr->SqueezeTitle == -1)
				    Scr->SqueezeTitle = TRUE;
				}
break;
case 138:
#line 476 "gram.y"
{ Scr->SqueezeTitle = FALSE; }
break;
case 139:
#line 477 "gram.y"
{ list = &Scr->DontSqueezeTitleL; }
break;
case 142:
#line 482 "gram.y"
{
				if (Scr->FirstTime) {
				   do_squeeze_entry (list, yyvsp[-3].ptr, yyvsp[-2].num, yyvsp[-1].num, yyvsp[0].num);
				}
			}
break;
case 146:
#line 496 "gram.y"
{ if (Scr->FirstTime)
					    AddToList(list, yyvsp[0].ptr, 0);
					}
break;
case 150:
#line 508 "gram.y"
{ if (Scr->FirstTime) AddToList(list, yyvsp[-1].ptr, yyvsp[0].ptr); }
break;
case 154:
#line 518 "gram.y"
{ AddToMenu(root, "", Action, NULL, yyvsp[0].num,
						NULLSTR, NULLSTR);
					  Action = "";
					}
break;
case 158:
#line 531 "gram.y"
{ AddToMenu(root, yyvsp[-1].ptr, Action, pull, yyvsp[0].num,
						NULLSTR, NULLSTR);
					  Action = "";
					  pull = NULL;
					}
break;
case 159:
#line 536 "gram.y"
{
					  AddToMenu(root, yyvsp[-6].ptr, Action, pull, yyvsp[0].num,
						yyvsp[-4].ptr, yyvsp[-2].ptr);
					  Action = "";
					  pull = NULL;
					}
break;
case 160:
#line 544 "gram.y"
{ yyval.num = yyvsp[0].num; }
break;
case 161:
#line 545 "gram.y"
{
				yyval.num = yyvsp[-1].num;
				Action = yyvsp[0].ptr;
				switch (yyvsp[-1].num) {
				  case F_MENU:
				    pull = GetRoot (yyvsp[0].ptr, NULLSTR,NULLSTR);
				    pull->prev = root;
				    break;
				  case F_WARPRING:
				    if (!CheckWarpRingArg (Action)) {
					twmrc_error_prefix();
					fprintf (stderr,
			"ignoring invalid f.warptoring argument \"%s\"\n",
						 Action);
					yyval.num = F_NOP;
				    }
				  case F_WARPTOSCREEN:
				    if (!CheckWarpScreenArg (Action)) {
					twmrc_error_prefix();
					fprintf (stderr,
			"ignoring invalid f.warptoscreen argument \"%s\"\n",
					         Action);
					yyval.num = F_NOP;
				    }
				    break;
				  case F_COLORMAP:
				    if (CheckColormapArg (Action)) {
					yyval.num = F_COLORMAP;
				    } else {
					twmrc_error_prefix();
					fprintf (stderr,
			"ignoring invalid f.colormap argument \"%s\"\n",
						 Action);
					yyval.num = F_NOP;
				    }
				    break;
				} /* end switch */
				   }
break;
case 162:
#line 586 "gram.y"
{ yyval.num = yyvsp[0].num; }
break;
case 163:
#line 587 "gram.y"
{ yyval.num = yyvsp[0].num; }
break;
case 164:
#line 588 "gram.y"
{ yyval.num = -(yyvsp[0].num); }
break;
case 165:
#line 591 "gram.y"
{ yyval.num = yyvsp[0].num;
					  if (yyvsp[0].num == 0)
						yyerror("bad button 0");

					  if (yyvsp[0].num > MAX_BUTTONS)
					  {
						yyval.num = 0;
						yyerror("button number too large");
					  }
					}
break;
case 166:
#line 603 "gram.y"
{ ptr = strdup(yyvsp[0].ptr);
					  RemoveDQuote(ptr);
					  yyval.ptr = ptr;
					}
break;
case 167:
#line 608 "gram.y"
{ yyval.num = yyvsp[0].num; }
break;
#line 1732 "gram.c"
    }
    yyssp -= yym;
    yystate = *yyssp;
    yyvsp -= yym;
    yym = yylhs[yyn];
    if (yystate == 0 && yym == 0)
    {
#if YYDEBUG
        if (yydebug)
            printf("%sdebug: after reduction, shifting from state 0 to\
 state %d\n", YYPREFIX, YYFINAL);
#endif
        yystate = YYFINAL;
        *++yyssp = YYFINAL;
        *++yyvsp = yyval;
        if (yychar < 0)
        {
            if ((yychar = yylex()) < 0) yychar = 0;
#if YYDEBUG
            if (yydebug)
            {
                yys = 0;
                if (yychar <= YYMAXTOKEN) yys = yyname[yychar];
                if (!yys) yys = "illegal-symbol";
                printf("%sdebug: state %d, reading %d (%s)\n",
                        YYPREFIX, YYFINAL, yychar, yys);
            }
#endif
        }
        if (yychar == 0) goto yyaccept;
        goto yyloop;
    }
    if ((yyn = yygindex[yym]) && (yyn += yystate) >= 0 &&
            yyn <= YYTABLESIZE && yycheck[yyn] == yystate)
        yystate = yytable[yyn];
    else
        yystate = yydgoto[yym];
#if YYDEBUG
    if (yydebug)
        printf("%sdebug: after reduction, shifting from state %d \
to state %d\n", YYPREFIX, *yyssp, yystate);
#endif
    if (yyssp >= yysslim && yygrowstack())
    {
        goto yyoverflow;
    }
    *++yyssp = yystate;
    *++yyvsp = yyval;
    goto yyloop;
yyoverflow:
    yyerror("yacc stack overflow");
yyabort:
    if (yyss)
            free(yyss);
    if (yyvs)
            free(yyvs);
    yyss = yyssp = NULL;
    yyvs = yyvsp = NULL;
    yystacksize = 0;
    return (1);
yyaccept:
    if (yyss)
            free(yyss);
    if (yyvs)
            free(yyvs);
    yyss = yyssp = NULL;
    yyvs = yyvsp = NULL;
    yystacksize = 0;
    return (0);
}
